@ECHO OFF

CD /D %~dp0

SET TMP_DIR=tools\tmp
SET PATH=%~dp0\tools\UnxUtils\bin;%PATH%

:EXTRACT_JDK
SET JDK_ZIP=
FOR %%f IN (openjdk*.zip) DO SET JDK_ZIP=%%f
IF "%JDK_ZIP%" == "" GOTO ERR_NOTFOUND_JDK_ZIP
ECHO Extracting archive: %JDK_ZIP%
unzip -oq "%JDK_ZIP%"

:FIND_JDK
SET JDK_DIR=
FOR /d %%f IN (jdk*) DO SET JDK_DIR=%%f
IF "%JDK_DIR%" == "" GOTO ERR_NOTFOUND_JDK_DIR
SET JAVA_HOME=%~dp0%JDK_DIR%
SET PATH=%JAVA_HOME%\bin;%PATH%

:EXTRACT_JFX_SDK
SET JFX_SDK_ZIP=
FOR %%f IN (openjfx*sdk.zip) DO SET JFX_SDK_ZIP=%%f
IF "%JFX_SDK_ZIP%" == "" GOTO ERR_NOTFOUND_JFX_SDK_ZIP
ECHO Extracting archive: %JFX_SDK_ZIP%
unzip -oq "%JFX_SDK_ZIP%" -d %TMP_DIR% 

:FIND_JFX_SDK
SET JFX_SDK_DIR=
FOR /d %%f IN (%TMP_DIR%\javafx-sdk*) DO SET JFX_SDK_DIR=%%f
IF "%JFX_SDK_DIR%" == "" GOTO ERR_NOTFOUND_JFX_SDK_DIR

:EXTRACT_JFX_JMODS
SET JFX_JMODS_ZIP=
FOR %%f IN (openjfx*jmods.zip) DO SET JFX_JMODS_ZIP=%%f
IF "%JFX_JMODS_ZIP%" == "" GOTO ERR_NOTFOUND_JFX_JMODS_ZIP
ECHO Extracting archive: %JFX_JMODS_ZIP%
unzip -oq "%JFX_JMODS_ZIP%" -d %TMP_DIR% 

:FIND_JFX_JMODS
SET JFX_JMODS_DIR=
FOR /d %%f IN (%TMP_DIR%\javafx-jmods*) DO SET JFX_JMODS_DIR=%%f
IF "%JFX_JMODS_DIR%" == "" GOTO ERR_NOTFOUND_JFX_JMODS_DIR

:MERGE_SOURCES
ECHO Extracting archive: %JFX_SDK_DIR%\lib\src.zip
unzip -oq "%JFX_SDK_DIR%\lib\src.zip" -d "%TMP_DIR%\src"
PUSHD %TMP_DIR%\src
ECHO Adding to archive: %JDK_DIR%lib\src.zip
zip -9qr "%~dp0%JDK_DIR%\lib\src.zip" .
POPD
del /F "%JFX_SDK_DIR%\lib\src.zip"

:MERGE_MODULES
xcopy "%JFX_SDK_DIR%" "%JDK_DIR%" /Y /D /S /E /Q > nul 2>&1
xcopy "%JFX_JMODS_DIR%" "%JDK_DIR%\jmods" /Y /D /S /E /Q > nul 2>&1

DIR /B "%JDK_DIR%\jmods\java*" | sed ":a;N;$!ba; s/.jmod\n/,/g; s/.jmod$//g; s/ //g;" > %TMP_DIR%\modules-java.tmp
SET /P JAVA_MODULES= < %TMP_DIR%\modules-java.tmp

DIR /B "%JDK_DIR%\jmods\jdk*" | sed ":a;N;$!ba; s/.jmod\n/,/g; s/.jmod$//g; s/ //g;" > %TMP_DIR%\modules-jdk.tmp
SET /P JDK_MODULES= < %TMP_DIR%\modules-jdk.tmp

ECHO Creating: %JDK_DIR%\lib\modules
jlink --compress=0 --module-path "%JAVA_HOME%\jmods" --add-modules %JAVA_MODULES%,%JDK_MODULES% --output %TMP_DIR%\output
copy /Y %TMP_DIR%\output\lib\modules "%JDK_DIR%\lib\modules" > nul 2>&1

ECHO.
ECHO %JDK_DIR% ̍쐬܂B

GOTO END

:ERR_NOTFOUND_JDK_ZIP
ECHO openjdk*.zip Ɉvt@C܂B
GOTO END

:ERR_NOTFOUND_JDK_DIR
ECHO jdk* ɈvtH_[܂B
GOTO END

:ERR_NOTFOUND_JFX_SDK_ZIP
ECHO openjfx*sdk.zip Ɉvt@C܂B
GOTO END

:ERR_NOTFOUND_JFX_SDK_DIR
ECHO %TMP_DIR%\javafx-sdk* ɈvtH_[܂B
GOTO END

:ERR_NOTFOUND_JFX_JMODS_ZIP
ECHO openjfx*jmods.zip Ɉvt@C܂B
GOTO END

:ERR_NOTFOUND_JFX_JMODS_DIR
ECHO %TMP_DIR%\javafx-jmods* ɈvtH_[܂B
GOTO END

:END
rmdir /S /Q %TMP_DIR% > nul 2>&1
PAUSE
